package com.style24.batch.biz.job.customer;

import com.gagaframework.web.parameter.GagaMap;
import com.style24.batch.biz.job.TsbAbstractJob;
import com.style24.batch.biz.service.TsbCustomerService;
import com.style24.batch.support.env.TsbConstants;
import com.style24.core.biz.service.TscEnvsetService;
import com.style24.core.support.env.TscConstants;
import com.style24.persistence.domain.Customer;
import com.style24.persistence.domain.CustomerSearch;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collection;

/**
 * 휴면전환 예정 알림
 *
 * @author jsshin
 * @since 2021.03.08
 */
@Component
@Slf4j
public class TsbDormantScheduleJob extends TsbAbstractJob<Collection<Customer>, GagaMap, GagaMap> {

	@Autowired
	private TsbCustomerService customerService;

	@Autowired
	private TscEnvsetService coreEnvsetService;

	private int succCnt = 0;
	private int failCnt = 0;

	@Override
	public Collection<Customer> read() throws Exception {
		// 휴면회원선정일수 가져오기
		int selectDays = coreEnvsetService.getDormantMemberSelectDays(TscConstants.Site.STYLE24.value());
		// 휴면회원전환일수
		int dormantConversionDay = coreEnvsetService.getDormantMemberConvertDays(TscConstants.Site.STYLE24.value());
		CustomerSearch customerSearch = new CustomerSearch();
		customerSearch.setDormantSelectDays(selectDays);
		customerSearch.setDormantConversionDay(dormantConversionDay);
		customerSearch.setSiteCd(TscConstants.Site.STYLE24.value());
		customerSearch.setRegNo(TsbConstants.REG_NO);
		customerSearch.setUpdNo(TsbConstants.REG_NO);
		return customerService.getDormantCustomerScheduleList(customerSearch);
	}

	@Override
	public GagaMap process(Collection<Customer> customerCollection) throws Exception {
		return customerService.sendDormantCustomerSchedule(customerCollection);
	}

	@Override
	public GagaMap write(GagaMap result) throws Exception {
		succCnt = result.getInt("succCnt");
		failCnt = result.getInt("failCnt");
		return result;
	}

	@Override
	public void notify(GagaMap result) throws Exception {
		super.printResult(succCnt, failCnt);
	}
}
